

/**** Fichiers d'inclusion ****/
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <libwebsockets.h>
#include <string.h>
#include <fcntl.h>
#include <sys/socket.h>
#include <sys/ioctl.h>
#include <linux/if.h>
#include <linux/if_tun.h>
#include <sys/types.h>
#include "serveur.h"

/**** constantes ****/
#define TAP_PRINCIPAL   "/dev/net/tun"
/**** globale ****/
unsigned char buffer[1600]={0};
char recu[1600]={0};
int fd;
static char *a_name;


/*interface virtuelle*/
int creationInterfaceVirtuelle(char *nom)
{
struct ifreq interface;
int fd,erreur;

/* Ouverture du peripherique principal */
if((fd=open(TAP_PRINCIPAL,O_RDWR|O_NONBLOCK))<0)return fd;
/* Preparation de la structure */
memset(&interface,0,sizeof(interface));
interface.ifr_flags=IFF_TAP|IFF_NO_PI;
if(nom!=NULL) strncpy(interface.ifr_name,nom,IFNAMSIZ);
/* Creation de l'interface */
if((erreur=ioctl(fd,TUNSETIFF,(void *)&interface))<0){ close(fd); return erreur; }
/* Recuperation du nom de l'interface */
if(nom!=NULL)strcpy(nom,interface.ifr_name);
return fd;
}



///convertion necessaire pour que le systeme comprenne mon message
char converseHexaChar(char val1,char val2){
    char r1,r2,result;

if(val1>='a')
    {r1 = val1 - 'a'+10;}
else
    {r1 = val1 - '0';}
if(val2>='a')
    {r2 = val2 - 'a'+10;}
else
    {r2 = val2 - '0';}

    result = r1 << 4;
    result += r2;
    return result;

}

int conv(char *tab1,char *tab2){

    for(int i=0;i<=300;i++)
    {
        tab2[i]=converseHexaChar(tab1[i*3],tab1[i*3+1]);
    }

return 0;
}


/**** fonction serveur ****/
static int callback_http(struct lws *wsi,
                         enum lws_callback_reasons reason, void *user,
                         void *in, size_t len)
{
	return 0;
}

static int callback_my(struct lws *wsi,
                                   enum lws_callback_reasons reason,
                                   void *user, void *in, size_t len)
{
    static char *message=NULL;
    static int msize=0;
    switch (reason) {
        case LWS_CALLBACK_ESTABLISHED: 
            printf("connection etablie\n");
            lws_callback_on_writable(wsi);
            break;

        case LWS_CALLBACK_RECEIVE: {
   	        memcpy(recu,in,len);

//////envoi des donnees recues du simulateur vers l'interface virtuelle.///////////////////
            conv(recu,(char *)buffer);
            write(fd,buffer,((len+1)/3));
            lws_callback_on_writable(wsi);
            break;    
            }

        case LWS_CALLBACK_SERVER_WRITEABLE: {
/////////////lecture des donnees sur l'interface et construction d'une trame de type String en hexadecimal///////////
            msize=read(fd,buffer,1600);
            if(msize>=0){
                message=malloc(LWS_SEND_BUFFER_PRE_PADDING+LWS_SEND_BUFFER_POST_PADDING+3*msize);
                if(message==NULL){perror("alloc.message"); exit(EXIT_FAILURE); }

                printf("\n Read bytes from device %s \n", a_name);
                for(int i=0;i<msize;i++){ 
                    sprintf(&message[LWS_PRE+(i*3)],"%02x ",buffer[i]);
                }
                
                //envoi du paquet ICMP recu par le PING
                lws_write(wsi,(unsigned char*)&message[LWS_PRE],msize*3,LWS_WRITE_TEXT);
                free(message);
            }

            lws_callback_on_writable(wsi);
            break;
        }
        default:
            break;
    }
    
    return 0;
}

static struct lws_protocols protocols[] = {
    {"http-only",callback_http,0},
    {"my",callback_my,0},
    {NULL, NULL, 0}
};


int main(void) {
    int port = 9500;
    a_name = malloc(IFNAMSIZ);
    strcpy(a_name,"tap0");
    fd=creationInterfaceVirtuelle(a_name);
    struct lws_context_creation_info info;
    memset(&info,0,sizeof info);
    info.port=port;
    info.protocols=protocols;
    info.gid=-1;
    info.uid=-1;

    // create lws context representing this server
    struct lws_context *context = lws_create_context(&info);
        if (context == NULL) {
        fprintf(stderr, "lws init failed\n");
        return -1;
        }
    
    printf("starting server...\n");
    while (1)
    {
        lws_service(context, 50);
    }
    lws_context_destroy(context);

    return 0;
}
